"use strict";

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /** 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (C) YoYoDyne Systems, Inc - All Rights Reserved
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Unauthorized copying of this file, via any medium is strictly prohibited
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Proprietary and confidential
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Written by Rahul Choudhary <rahulchoudhary666666@gmail.com>, April 2020
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _constant = require("./constant");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BinaryHeap = function () {
  /**
   * Summary: this is constructor
   * @author : Rahul Choudhary
   * @param {[Object | number | string]} inputBT : this will be a list of Object or number or string
   * @param {number} type : this will be a number (only possible values 1 or 2)
   * @returns : nothing
   */
  function BinaryHeap(inputBT, type) {
    var _this = this;

    _classCallCheck(this, BinaryHeap);

    try {
      var isFirstParamValid = true;
      this.isNodeValid = true;
      if (inputBT && inputBT.length) {
        this.nodeType = _typeof(inputBT[0]);
        this.draftBT = this.nodeType == _typeof({}) ? JSON.parse(JSON.stringify(inputBT)) : [];
        this.resHeap = JSON.parse(JSON.stringify(inputBT));
        this.heapSize = this.resHeap.length;
        try {
          this.resHeap.map(function (obj) {
            if (obj.hasOwnProperty("key")) {
              if (isNaN(obj.key)) {
                // key is not a number
                var e = new Error("Key is not a number!");
                _this.isNodeValid = false;
                throw e;
              }
            } else {
              if (isNaN(obj)) {
                // item is not a number
                isFirstParamValid = false;
                var _e = new Error("List item should be either a number or an object with attribute named key!");
                _this.isNodeValid = false;
                throw _e;
              } else {
                // item is number
                var key = parseFloat(obj);
                _this.draftBT.push(key);
              }
            }
          });
        } catch (e) {
          console.log("\tError: " + e.message);
        }
      } else {
        var e = new Error("First parameter of constructor can not be empty!");
        this.isNodeValid = false;
        throw e;
      }
      if (isFirstParamValid && !isNaN(type) && type !== null) {
        this.type = type;
        this.makeHeap();
      } else if (isFirstParamValid && (type === null || type === undefined || isNaN(type))) {
        var _e2 = new Error("Type passed to constructor as second argument is " + type + " which is of type " + (typeof type === "undefined" ? "undefined" : _typeof(type)) + (".\n\t Only 1 or 2 are accepted values as second parameter. \n\n\t Relation between (node or item)'s priority and (node or item)'s key attribute value will depend on this parameter value. \n\t 1: " + _constant.BINARY_HEAP_IDENTIFIER.MAX_HEAP.description + "\n\t 2: " + _constant.BINARY_HEAP_IDENTIFIER.MIN_HEAP.description + " \n\n\t So if you want that item's with high key attribute value should have high priority in priority queue,then pass 1 as second parameter value.\n\t Otherwise if you want that item's with low key attribute value should have high priority in priority queue,then pass 2 as second parameter value."));
        this.isNodeValid = false;
        throw _e2;
      }
    } catch (e) {
      console.error("\tError: " + e.message);
    }
  }
  /**
   * Summary : Checks if binary heap property is voilated
   * @param {number} cI :  index of child in array representation of heap
   * @param {number} pI : index of parent in array representation of heap
   * @returns {Boolean} : true if heap property voilated
   */


  _createClass(BinaryHeap, [{
    key: "isHeapPropertyVoilated",
    value: function isHeapPropertyVoilated(cI, pI) {
      try {
        // child index is out from the heap 
        if (cI >= this.heapSize) return false;
        var a = this.getKey(this.resHeap[pI]);
        var b = this.getKey(this.resHeap[cI]);
        if (isNaN(a) || isNaN(b)) {
          throw "Error: Input tree node are not comparable!";
        } else {

          if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MAX_HEAP.id) {
            return a < b;
          } else if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MIN_HEAP.id) {
            return a > b;
          }
        }
      } catch (e) {
        console.log(e);
      }
    }

    /**
     * Summary : Swaps item at array[cI] with array[pI]
     * @param {number} cI 
     * @param {number} pI 
     * @returns : nothing
     */

  }, {
    key: "swap",
    value: function swap(cI, pI) {
      var tmp = this.resHeap[cI];
      this.resHeap[cI] = this.resHeap[pI];
      this.resHeap[pI] = tmp;
    }

    /**
     * Summary : Calculates parent index for a given child index 
     * @param {number} cI : index of child element
     * @returns : index of parent element of given child element 
     */

  }, {
    key: "calcParentIndex",
    value: function calcParentIndex(cI) {
      var pI = cI % 2 == 0 ? (cI - 2) / 2 : (cI - 1) / 2;
      return pI;
    }

    /**
     * Summary : Calculates possible child index's (left or right or both) for a given parent index 
     * @param {number} pI : index of parent element
     * @returns : index of child element of given parent element with whom swap is required
     */

  }, {
    key: "calcChildIndex",
    value: function calcChildIndex(pI) {
      var swapNode = null,
          cI = NaN;
      var pLimit = this.heapSize % 2 == 0 ? parseInt((this.heapSize - 2) / 2) : parseInt((this.heapSize - 1) / 2);
      if (pI > pLimit) return cI;
      var lI = 2 * pI + 1,
          rI = 2 * pI + 2;
      if (lI >= this.heapSize && rI >= this.heapSize) return cI;
      var leftChildVoilationFlag = this.isHeapPropertyVoilated(lI, pI);
      var rightChildVoilationFlag = this.isHeapPropertyVoilated(rI, pI);
      if (leftChildVoilationFlag && rightChildVoilationFlag) {
        //Check from whom parent should be swapped
        //a and b are left and right node values respectively
        var a = this.getKey(this.resHeap[lI]);
        var b = this.getKey(this.resHeap[rI]);
        if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MAX_HEAP.id) {
          swapNode = a > b ? _constant.NODE_IDENTIFIER.LEFT : _constant.NODE_IDENTIFIER.RIGHT;
          cI = a > b ? lI : rI;
        } else if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MIN_HEAP.id) {
          swapNode = a < b ? _constant.NODE_IDENTIFIER.LEFT : _constant.NODE_IDENTIFIER.RIGHT;
          cI = a < b ? lI : rI;
        }
      } else if (leftChildVoilationFlag) {
        //Swap parent with left child
        swapNode = _constant.NODE_IDENTIFIER.LEFT;
        cI = lI;
      } else if (rightChildVoilationFlag) {
        //Swap parent with right child
        swapNode = _constant.NODE_IDENTIFIER.RIGHT;
        cI = rI;
      } else {
        //No swapping required
      }
      return cI;
    }

    /**
     * Summary : this checks heap property for all the nodes from given node to root upward
     * Description : this method assumes that subtree rooted at cI is already a heap, so checks from cI to root if a swap is required
     * @param {number} cI : child index
     * @returns : nothing 
     */

  }, {
    key: "heapifyBottomToTop",
    value: function heapifyBottomToTop(cI) {
      var pI = this.calcParentIndex(cI);
      while (pI >= 0 && this.isHeapPropertyVoilated(cI, pI)) {
        this.swap(cI, pI);
        // New Child
        cI = pI;
        // New Parent
        pI = this.calcParentIndex(cI);
      }
    }
    /**
     * Summary : this checks heap property for all the nodes from given node to leaf downward 
     * Description : this method assumes that entire subtree other than the subtree rooted at pI is already a heap, so convert subtree rooted at pI to heap
     * @param {number} pI : parent index
     * @returns : nothing 
     */

  }, {
    key: "heapifyTopToBottom",
    value: function heapifyTopToBottom(pI) {
      var cI = this.calcChildIndex(pI);
      var pLimit = this.heapSize % 2 == 0 ? parseInt((this.heapSize - 2) / 2) : parseInt((this.heapSize - 1) / 2);
      while (!isNaN(cI) && pI <= pLimit && cI >= 0) {
        this.swap(cI, pI);
        // New Parent
        pI = cI;
        // New Child
        if (pI <= pLimit) cI = this.calcChildIndex(pI);
      }
    }
    /**
     * Summary : Heapify all internal nodes
     * @returns : nothing
     */

  }, {
    key: "makeHeap",
    value: function makeHeap() {
      var n = this.heapSize;
      for (var i = parseInt(n / 2); i >= 0; i--) {
        //Heapify all internal nodes , because leaf node's are already heap
        this.heapifyTopToBottom(i);
      }
    }
    /**
     * Summary : Test if the given item is appropriate to insert in heap
     * @param {Object | number | string} item 
     * @returns {Boolean} : true if item is valid
     */

  }, {
    key: "testItem",
    value: function testItem(item) {
      return this.nodeType == (typeof item === "undefined" ? "undefined" : _typeof(item)) || !isNaN(item);
    }
    /**
     * Summary : insert a item to heap 
     * @param {Object | number | string} item 
     * @returns : nothing
     */

  }, {
    key: "insert",
    value: function insert(item) {
      try {
        if (this.testItem(item)) {
          this.resHeap.push(item);
          this.heapSize += 1;
          this.heapifyBottomToTop(this.heapSize - 1);
        } else {
          throw "Error: Invalid item is provided!";
        }
      } catch (e) {
        console.log(e);
      }
    }
    /**
     * Summary : returns the key of a node
     * @param {Object | number | string} item
     * @returns {number} 
     */

  }, {
    key: "getKey",
    value: function getKey(item) {
      return this.nodeType == _typeof({}) ? parseFloat(item.key) : this.nodeType == _typeof("") || this.nodeType == _typeof(0) ? parseFloat(item) : NaN;
    }
    /**
     * Summary : update(increase/decrease) the key|priority value
     * @param {Object | number | string} newItem 
     * @param {number} position 
     * @returns : nothing
     */

  }, {
    key: "updateKey",
    value: function updateKey(newItem, position) {
      try {
        if (!(position >= 0 && position < this.heapSize)) {
          throw "Error: Second param of updateKey function should be between 0 and " + (this.heapSize - 1) + " inclusive.";
        }
        if (this.testItem(newItem)) {
          var prevItem = this.resHeap[position];
          this.resHeap[position] = newItem;
          var diff = this.getKey(newItem) - this.getKey(prevItem);
          if (diff < 0) {
            // Newer item's key is less than older item
            if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MAX_HEAP.id) {
              this.heapifyTopToBottom(position);
            } else {
              this.heapifyBottomToTop(position);
            }
          } else if (diff > 0) {
            // Newer item's key is greater than older item
            if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MIN_HEAP.id) {
              this.heapifyTopToBottom(position);
            } else {
              this.heapifyBottomToTop(position);
            }
          }
        } else {
          throw "Error: Invalid item is provided!";
        }
      } catch (error) {
        console.log(error);
      }
    }

    /**
     * Summary : returns max key element or min key element in case of max heap and min heap respectively
     * @returns {Object | number | string} item
     */

  }, {
    key: "extract",
    value: function extract() {
      try {
        if (this.heapSize > 0) {
          var extractedNode = this.resHeap[0];
          this.swap(0, this.heapSize - 1);
          this.resHeap = this.resHeap.slice(0, this.heapSize - 1);
          this.heapSize -= 1;
          this.heapifyTopToBottom(0);
          return extractedNode;
        } else {
          throw "Error: Nothing to extract ,heap is empty!";
        }
      } catch (e) {
        console.log(e);
      }
    }
    /**
     * Summary : performs heap sort on heap items to get required sorted order
     * @param {number} order : (1 for increasing order and 2 for decreasing order)
     * @returns {[Object | number | string]} : sorted list 
     */

  }, {
    key: "sort",
    value: function sort() {
      var order = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constant.SORT_ORDER.INC;

      try {
        var sortedList = [];
        var n = this.heapSize;
        var oldHeapCopy = JSON.parse(JSON.stringify(this.resHeap));
        for (var i = 0; i < n; i++) {
          var extractedNode = this.extract();
          sortedList.push(extractedNode);
        }
        this.resHeap = oldHeapCopy;
        this.heapSize = n;
        if (this.type == _constant.BINARY_HEAP_IDENTIFIER.MAX_HEAP.id) {
          if (order == _constant.SORT_ORDER.INC) {
            return sortedList.reverse();
          } else {
            return sortedList;
          }
        } else {
          if (order == _constant.SORT_ORDER.DEC) {
            return sortedList.reverse();
          } else {
            return sortedList;
          }
        }
      } catch (e) {
        console.log(e);
      }
    }
  }]);

  return BinaryHeap;
}();

module.exports = BinaryHeap;